## centreon-broker 19.10.2

=== CMakeLists.txt ===
##
## Copyright 2009-2019 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

#
# Global settings.
#

# Set necessary settings.
cmake_minimum_required(VERSION 2.8)
project("Centreon Broker" C CXX)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
set(INC_DIR "${PROJECT_SOURCE_DIR}/core/inc")
include_directories("${INC_DIR}")
set(INC_DIR "${PROJECT_SOURCE_DIR}/core/inc/com/centreon/broker")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/core/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/core/test")

# Version.
set(CENTREON_BROKER_MAJOR 19)
set(CENTREON_BROKER_MINOR 10)
set(CENTREON_BROKER_PATCH 2)
if (CENTREON_BROKER_PRERELEASE)
  set(CENTREON_BROKER_VERSION "${CENTREON_BROKER_MAJOR}.${CENTREON_BROKER_MINOR}.${CENTREON_BROKER_PATCH}-${CENTREON_BROKER_PRERELEASE}")
else()
  set(CENTREON_BROKER_VERSION "${CENTREON_BROKER_MAJOR}.${CENTREON_BROKER_MINOR}.${CENTREON_BROKER_PATCH}")
endif ()
add_definitions(-DCENTREON_BROKER_VERSION=\"${CENTREON_BROKER_VERSION}\")
configure_file(
  "${INC_DIR}/version.hh.in"
  "${INC_DIR}/version.hh"
  "@ONLY"
)

include(ExternalProject)

ExternalProject_Add( json11_lib
                     GIT_REPOSITORY https://github.com/dropbox/json11/
                     TIMEOUT 10
                     INSTALL_COMMAND ""
                     LOG_DOWNLOAD ON
                     LOG_CONFIGURE ON
                     LOG_BUILD ON)

ExternalProject_Get_Property(json11_lib source_dir)
ExternalProject_Get_Property(json11_lib binary_dir)

link_directories(${binary_dir})
include_directories(${source_dir})

#
# Check and/or find required components.
#

# Find Qt.
find_package(Qt4 4.7.4 COMPONENTS QtCore QtNetwork QtSql QtXml REQUIRED)

# Find zlib.
find_package(ZLIB REQUIRED)

include(${QT_USE_FILE})
set(QT_VERSION "${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}")
if (("${QT_VERSION}" VERSION_EQUAL "4.7.0")
    OR ("${QT_VERSION}" VERSION_EQUAL "4.7.1"))
  message(WARNING "Qt versions 4.7.0 and 4.7.1 contain a bug that might prevent Centreon Broker from working properly.")
endif ()

#
# Get distributions name
#
if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
  message(STATUS "Attempting to determine OS distributor.")
  execute_process(COMMAND "lsb_release" "--short" "--id"
    RESULT_VARIABLE RETCODE
    OUTPUT_VARIABLE OS_DISTRIBUTOR
    ERROR_QUIET)
  if (RETCODE EQUAL 0)
    string(REGEX REPLACE "\n$" "" OS_DISTRIBUTOR "${OS_DISTRIBUTOR}")
  else ()
    message(WARNING "lsb_release in not installed")
    set(OS_DISTRIBUTOR "${CMAKE_SYSTEM_NAME}")
  endif ()
elseif ()
  set(OS_DISTRIBUTOR "${CMAKE_SYSTEM_NAME}")
endif ()


#
# Options.
#

# Main directory.
if (WITH_PREFIX)
  set(CMAKE_INSTALL_PREFIX "${WITH_PREFIX}")
endif ()

# Executable directory.
if (WITH_PREFIX_BIN)
  set(PREFIX_BIN "${WITH_PREFIX_BIN}")
else ()
  set(PREFIX_BIN "${CMAKE_INSTALL_PREFIX}/bin")
endif ()

# Configuration directory.
if (WITH_PREFIX_CONF)
  set(PREFIX_CONF "${WITH_PREFIX_CONF}")
else ()
  set(PREFIX_CONF "${CMAKE_INSTALL_PREFIX}/etc")
endif ()

# Library directory.
if (WITH_PREFIX_LIB)
  set(PREFIX_LIB "${WITH_PREFIX_LIB}")
else ()
  set(PREFIX_LIB "${CMAKE_INSTALL_PREFIX}/lib")
endif ()

# Modules directory.
if (WITH_PREFIX_MODULES)
  set(PREFIX_MODULES "${WITH_PREFIX_MODULES}")
else ()
  set(PREFIX_MODULES "${PREFIX_LIB}/centreon-broker")
endif ()

# var directory.
if (WITH_PREFIX_VAR)
  set(PREFIX_VAR "${WITH_PREFIX_VAR}")
else ()
  set(PREFIX_VAR "${CMAKE_INSTALL_PREFIX}/var")
endif ()

# Development headers directory.
if (WITH_PREFIX_INC)
  set(PREFIX_INC "${WITH_PREFIX_INC}")
else ()
  set(PREFIX_INC "${CMAKE_INSTALL_PREFIX}/include/centreon-broker")
endif ()

# User.
if (WITH_USER)
  set(USER "${WITH_USER}")
else ()
  set(USER "root")
endif ()

# Group.
if (WITH_GROUP)
  set(GROUP "${WITH_GROUP}")
else ()
  set(GROUP "root")
endif ()

# Code coverage on unit tests
option(WITH_COVERAGE "Add code coverage on unit tests." OFF)
if (WITH_TESTING AND WITH_COVERAGE)
  set(CMAKE_BUILD_TYPE "Debug")
  include(cmake/CodeCoverage.cmake)
  APPEND_COVERAGE_COMPILER_FLAGS()
endif()

# Set startup script to auto if not defined.
if (NOT WITH_STARTUP_SCRIPT)
  set(WITH_STARTUP_SCRIPT "auto")
endif ()

# Check which startup script to use.
if (WITH_STARTUP_SCRIPT STREQUAL "auto")
  if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(WITH_STARTUP_SCRIPT "sysv")
  else ()
    message(STATUS "Centreon Broker does not provide startup script for ${CMAKE_SYSTEM_NAME}.")
    set(WITH_STARTUP_SCRIPT "no")
  endif ()
endif ()

# Startup dir.
if (WITH_STARTUP_SCRIPT STREQUAL "sysv"
    OR WITH_STARTUP_SCRIPT STREQUAL "systemd")
  # Set destination directory.
  if (WITH_STARTUP_DIR)
    set(STARTUP_DIR "${WITH_STARTUP_DIR}")
  else ()
    set(STARTUP_DIR "/etc/init.d")
  endif ()
endif ()

# Configure files.
if (WITH_DAEMONS)
  if (WITH_STARTUP_SCRIPT STREQUAL "systemd")
    configure_file("${PROJECT_SOURCE_DIR}/script/systemd/cbd.service.in"
     "${PROJECT_SOURCE_DIR}/script/cbd.service"
      @ONLY)
    install(FILES "${PROJECT_SOURCE_DIR}/script/cbd.service"
      DESTINATION "${STARTUP_DIR}")
  elseif (OS_DISTRIBUTOR STREQUAL "CentOS" OR OS_DISTRIBUTOR STREQUAL "RedHat")
    configure_file("${PROJECT_SOURCE_DIR}/script/redhat/cbd.init.d.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.init"
      @ONLY)
  elseif (OS_DISTRIBUTOR STREQUAL "Debian" OR OS_DISTRIBUTOR STREQUAL "Ubuntu")
    configure_file("${PROJECT_SOURCE_DIR}/script/debian/cbd.init.d.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.init"
      @ONLY)
    configure_file("${PROJECT_SOURCE_DIR}/script/debian/cbd.default.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.default"
      @ONLY)
    install(FILES "${PROJECT_SOURCE_DIR}/script/cbd.default"
      DESTINATION "/etc/default"
      RENAME "cbd")
  else ()
    configure_file("${PROJECT_SOURCE_DIR}/script/other/cbd.init.d.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.init"
      @ONLY)
  endif ()

  foreach (DAEMON_NAME IN LISTS WITH_DAEMONS)
    set(DAEMONS_CONFIGURATION
      "${DAEMONS_CONFIGURATION}  <cbd>\n  <name>${DAEMON_NAME}</name>\n    <configuration_file>${PREFIX_CONF}/${DAEMON_NAME}.xml</configuration_file>\n    <run>1</run>\n    <reload>1</reload>\n  </cbd>\n")
  endforeach ()

  configure_file("${PROJECT_SOURCE_DIR}/script/watchdog.xml.in"
    "${PROJECT_SOURCE_DIR}/script/watchdog.xml"
    @ONLY)
  install(FILES "${PROJECT_SOURCE_DIR}/script/watchdog.xml"
    DESTINATION "${PREFIX_CONF}")
  if (WITH_STARTUP_SCRIPT STREQUAL "sysv")
    install(PROGRAMS "${PROJECT_SOURCE_DIR}/script/cbd.init"
      DESTINATION "${STARTUP_DIR}"
      RENAME "cbd")
  endif ()
endif ()

if (WITH_CONFIG_FILES)
  configure_file("${PROJECT_SOURCE_DIR}/config/poller-module.xml.in"
    "${PROJECT_SOURCE_DIR}/config/poller-module.xml"
    @ONLY)
  configure_file("${PROJECT_SOURCE_DIR}/config/central-broker.xml.in"
    "${PROJECT_SOURCE_DIR}/config/central-broker.xml"
    @ONLY)
  configure_file("${PROJECT_SOURCE_DIR}/config/central-rrd.xml.in"
    "${PROJECT_SOURCE_DIR}/config/central-rrd.xml"
    @ONLY)
  configure_file("${PROJECT_SOURCE_DIR}/config/cbmod.cfg.in"
    "${PROJECT_SOURCE_DIR}/config/cbmod.cfg"
    @ONLY)

  install(FILES "${PROJECT_SOURCE_DIR}/config/poller-module.xml"
    DESTINATION "${PREFIX_CONF}")
  install(FILES "${PROJECT_SOURCE_DIR}/config/central-rrd.xml"
    DESTINATION "${PREFIX_CONF}")
  install(FILES "${PROJECT_SOURCE_DIR}/config/central-broker.xml"
    DESTINATION "${PREFIX_CONF}")
endif ()

# Monitoring engine (for testing).
if (WITH_MONITORING_ENGINE)
  set(MONITORING_ENGINE_ADDITIONAL "")
  set(MONITORING_ENGINE "${WITH_MONITORING_ENGINE}")
  if (WITH_MONITORING_ENGINE_MODULES)
    foreach (MODULE IN LISTS WITH_MONITORING_ENGINE_MODULES)
      set(MONITORING_ENGINE_ADDITIONAL
          "${MONITORING_ENGINE_ADDITIONAL}broker_module=${MODULE}\\n")
    endforeach ()
  endif ()
  if (WITH_MONITORING_ENGINE_INTERVAL_LENGTH)
    set(MONITORING_ENGINE_INTERVAL_LENGTH "${WITH_MONITORING_ENGINE_INTERVAL_LENGTH}")
  else ()
    set(MONITORING_ENGINE_INTERVAL_LENGTH 1)
  endif ()
endif ()

# DB parameters.
if (WITH_DB_TYPE)
  set(DB_TYPE "${WITH_DB_TYPE}")
  if (WITH_DB_HOST)
    set(DB_HOST "${WITH_DB_HOST}")
  else ()
    set(DB_HOST "localhost")
  endif ()
  if (WITH_DB_PORT)
    set(DB_PORT "${WITH_DB_PORT}")
  else ()
    set(DB_PORT "3306")
  endif ()
  if (WITH_DB_USER)
    set(DB_USER "${WITH_DB_USER}")
  else ()
    message(FATAL_ERROR "WITH_DB_USER is not specified.")
  endif ()
  if (WITH_DB_PASSWORD)
    set(DB_PASSWORD "${WITH_DB_PASSWORD}")
  else ()
    set(DB_PASSWORD "")
  endif ()
endif ()

# Broker vars
configure_file(
  "${INC_DIR}/vars.hh.in"
  "${INC_DIR}/vars.hh"
  "@ONLY"
)


#
# Targets.
#

# Some files must be processed by Qt's moc.
qt4_wrap_cpp(QT_WRAPPED_SOURCES
  "${INC_DIR}/logging/backend.hh"
  "${INC_DIR}/logging/manager.hh"
  "${INC_DIR}/processing/thread.hh"
)

# Core library.
set(LIBROKER_SOURCES
  # Sources.
  "${SRC_DIR}/bbdo/acceptor.cc"
  "${SRC_DIR}/bbdo/ack.cc"
  "${SRC_DIR}/bbdo/connector.cc"
  "${SRC_DIR}/bbdo/factory.cc"
  "${SRC_DIR}/bbdo/input.cc"
  "${SRC_DIR}/bbdo/input_buffer.cc"
  "${SRC_DIR}/bbdo/internal.cc"
  "${SRC_DIR}/bbdo/output.cc"
  "${SRC_DIR}/bbdo/stream.cc"
  "${SRC_DIR}/bbdo/version_response.cc"
  "${SRC_DIR}/ceof/ceof_writer.cc"
  "${SRC_DIR}/ceof/ceof_parser.cc"
  "${SRC_DIR}/ceof/ceof_iterator.cc"
  "${SRC_DIR}/ceof/ceof_token.cc"
  "${SRC_DIR}/ceof/ceof_serializer.cc"
  "${SRC_DIR}/ceof/ceof_deserializer.cc"
  "${SRC_DIR}/compression/factory.cc"
  "${SRC_DIR}/compression/internal.cc"
  "${SRC_DIR}/compression/opener.cc"
  "${SRC_DIR}/compression/stack_array.cc"
  "${SRC_DIR}/compression/stream.cc"
  "${SRC_DIR}/compression/zlib.cc"
  "${SRC_DIR}/config/applier/endpoint.cc"
  "${SRC_DIR}/config/applier/modules.cc"
  "${SRC_DIR}/config/applier/state.cc"
  "${SRC_DIR}/config/endpoint.cc"
  "${SRC_DIR}/config/logger.cc"
  "${SRC_DIR}/config/parser.cc"
  "${SRC_DIR}/config/state.cc"
  "${SRC_DIR}/database.cc"
  "${SRC_DIR}/database_config.cc"
  "${SRC_DIR}/database_preparator.cc"
  "${SRC_DIR}/database_query.cc"
  "${SRC_DIR}/exceptions/config.cc"
  "${SRC_DIR}/exceptions/corruption.cc"
  "${SRC_DIR}/exceptions/interrupt.cc"
  "${SRC_DIR}/exceptions/msg.cc"
  "${SRC_DIR}/exceptions/shutdown.cc"
  "${SRC_DIR}/exceptions/timeout.cc"
  "${SRC_DIR}/extcmd/command_client.cc"
  "${SRC_DIR}/extcmd/command_parser.cc"
  "${SRC_DIR}/extcmd/command_listener.cc"
  "${SRC_DIR}/extcmd/command_request.cc"
  "${SRC_DIR}/extcmd/command_result.cc"
  "${SRC_DIR}/extcmd/command_server.cc"
  "${SRC_DIR}/extcmd/factory.cc"
  "${SRC_DIR}/extcmd/internal.cc"
  "${SRC_DIR}/extcmd/json_command_parser.cc"
  "${SRC_DIR}/extcmd/plaintext_command_parser.cc"
  "${SRC_DIR}/extcmd/server_socket.cc"
  "${SRC_DIR}/file/cfile.cc"
  "${SRC_DIR}/file/directory_event.cc"
  "${SRC_DIR}/file/directory_watcher.cc"
  "${SRC_DIR}/file/factory.cc"
  "${SRC_DIR}/file/fifo.cc"
  "${SRC_DIR}/file/fs_browser.cc"
  "${SRC_DIR}/file/fs_file.cc"
  "${SRC_DIR}/file/internal.cc"
  "${SRC_DIR}/file/opener.cc"
  "${SRC_DIR}/file/qt_fs_browser.cc"
  "${SRC_DIR}/file/splitter.cc"
  "${SRC_DIR}/file/stream.cc"
  "${SRC_DIR}/instance_broadcast.cc"
  "${SRC_DIR}/io/data.cc"
  "${SRC_DIR}/io/endpoint.cc"
  "${SRC_DIR}/io/event_info.cc"
  "${SRC_DIR}/io/events.cc"
  "${SRC_DIR}/io/factory.cc"
  "${SRC_DIR}/io/properties.cc"
  "${SRC_DIR}/io/property.cc"
  "${SRC_DIR}/io/protocols.cc"
  "${SRC_DIR}/io/raw.cc"
  "${SRC_DIR}/io/stream.cc"

=== bam/CMakeLists.txt ===
##
## Copyright 2011-2016 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/bam/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/bam/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/bam/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")
set(INC_DIR "${INC_DIR}/com/centreon/broker/bam")

# BAM module.
set(BAM "20-bam")
set(BAM "${BAM}" PARENT_SCOPE)
add_library("${BAM}" SHARED
  # Sources.
  "${SRC_DIR}/availability_builder.cc"
  "${SRC_DIR}/availability_thread.cc"
  "${SRC_DIR}/ba.cc"
  "${SRC_DIR}/ba_status.cc"
  "${SRC_DIR}/ba_svc_mapping.cc"
  "${SRC_DIR}/ba_event.cc"
  "${SRC_DIR}/ba_duration_event.cc"
  "${SRC_DIR}/bool_aggregate.cc"
  "${SRC_DIR}/bool_and.cc"
  "${SRC_DIR}/bool_binary_operator.cc"
  "${SRC_DIR}/bool_call.cc"
  "${SRC_DIR}/bool_constant.cc"
  "${SRC_DIR}/bool_equal.cc"
  "${SRC_DIR}/bool_expression.cc"
  "${SRC_DIR}/bool_less_than.cc"
  "${SRC_DIR}/bool_metric.cc"
  "${SRC_DIR}/bool_more_than.cc"
  "${SRC_DIR}/bool_not.cc"
  "${SRC_DIR}/bool_not_equal.cc"
  "${SRC_DIR}/bool_operation.cc"
  "${SRC_DIR}/bool_or.cc"
  "${SRC_DIR}/bool_service.cc"
  "${SRC_DIR}/bool_value.cc"
  "${SRC_DIR}/bool_xor.cc"
  "${SRC_DIR}/computable.cc"
  "${SRC_DIR}/configuration/applier/ba.cc"
  "${SRC_DIR}/configuration/applier/bool_expression.cc"
  "${SRC_DIR}/configuration/applier/kpi.cc"
  "${SRC_DIR}/configuration/applier/meta_service.cc"
  "${SRC_DIR}/configuration/applier/state.cc"
  "${SRC_DIR}/configuration/ba.cc"
  "${SRC_DIR}/configuration/bool_expression.cc"
  "${SRC_DIR}/configuration/kpi.cc"
  "${SRC_DIR}/configuration/meta_service.cc"
  "${SRC_DIR}/configuration/reader.cc"
  "${SRC_DIR}/configuration/reader_exception.cc"
  "${SRC_DIR}/configuration/reader_v2.cc"
  "${SRC_DIR}/configuration/state.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/dimension_ba_event.cc"
  "${SRC_DIR}/dimension_kpi_event.cc"
  "${SRC_DIR}/dimension_ba_bv_relation_event.cc"
  "${SRC_DIR}/dimension_bv_event.cc"
  "${SRC_DIR}/dimension_timeperiod.cc"
  "${SRC_DIR}/dimension_timeperiod_exception.cc"
  "${SRC_DIR}/dimension_timeperiod_exclusion.cc"
  "${SRC_DIR}/dimension_ba_timeperiod_relation.cc"
  "${SRC_DIR}/dimension_truncate_table_signal.cc"
  "${SRC_DIR}/exp_builder.cc"
  "${SRC_DIR}/exp_parser.cc"
  "${SRC_DIR}/exp_tokenizer.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/event_cache_visitor.cc"
  "${SRC_DIR}/hst_svc_mapping.cc"
  "${SRC_DIR}/impact_values.cc"
  "${SRC_DIR}/inherited_downtime.cc"
  "${SRC_DIR}/kpi.cc"
  "${SRC_DIR}/kpi_ba.cc"
  "${SRC_DIR}/kpi_boolexp.cc"
  "${SRC_DIR}/kpi_event.cc"
  "${SRC_DIR}/kpi_meta.cc"
  "${SRC_DIR}/kpi_service.cc"
  "${SRC_DIR}/kpi_status.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/meta_service.cc"
  "${SRC_DIR}/meta_service_status.cc"
  "${SRC_DIR}/metric_book.cc"
  "${SRC_DIR}/metric_listener.cc"
  "${SRC_DIR}/monitoring_stream.cc"
  "${SRC_DIR}/rebuild.cc"
  "${SRC_DIR}/reporting_stream.cc"
  "${SRC_DIR}/service_book.cc"
  "${SRC_DIR}/service_listener.cc"
  "${SRC_DIR}/timeperiod_map.cc"
  # Headers.
  "${INC_DIR}/availability_builder.hh"
  "${INC_DIR}/availability_thread.hh"
  "${INC_DIR}/ba.hh"
  "${INC_DIR}/ba_status.hh"
  "${INC_DIR}/ba_svc_mapping.hh"
  "${INC_DIR}/ba_event.hh"
  "${INC_DIR}/ba_duration_event.hh"
  "${INC_DIR}/bool_aggregate.hh"
  "${INC_DIR}/bool_and.hh"
  "${INC_DIR}/bool_binary_operator.hh"
  "${INC_DIR}/bool_call.hh"
  "${INC_DIR}/bool_constant.hh"
  "${INC_DIR}/bool_equal.hh"
  "${INC_DIR}/bool_expression.hh"
  "${INC_DIR}/bool_less_than.hh"
  "${INC_DIR}/bool_metric.hh"
  "${INC_DIR}/bool_more_than.hh"
  "${INC_DIR}/bool_not.hh"
  "${INC_DIR}/bool_not_equal.hh"
  "${INC_DIR}/bool_operation.hh"
  "${INC_DIR}/bool_or.hh"
  "${INC_DIR}/bool_service.hh"
  "${INC_DIR}/bool_value.hh"
  "${INC_DIR}/bool_xor.hh"
  "${INC_DIR}/computable.hh"
  "${INC_DIR}/configuration/applier/ba.hh"
  "${INC_DIR}/configuration/applier/bool_expression.hh"
  "${INC_DIR}/configuration/applier/kpi.hh"
  "${INC_DIR}/configuration/applier/meta_service.hh"
  "${INC_DIR}/configuration/applier/state.hh"
  "${INC_DIR}/configuration/ba.hh"
  "${INC_DIR}/configuration/bool_expression.hh"
  "${INC_DIR}/configuration/kpi.hh"
  "${INC_DIR}/configuration/meta_service.hh"
  "${INC_DIR}/configuration/reader.hh"
  "${INC_DIR}/configuration/reader_exception.hh"
  "${INC_DIR}/configuration/reader_v2.hh"
  "${INC_DIR}/configuration/state.hh"
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/dimension_ba_event.hh"
  "${INC_DIR}/dimension_kpi_event.hh"
  "${INC_DIR}/dimension_ba_bv_relation_event.hh"
  "${INC_DIR}/dimension_bv_event.hh"
  "${INC_DIR}/dimension_timeperiod.hh"
  "${INC_DIR}/dimension_timeperiod_exception.hh"
  "${INC_DIR}/dimension_timeperiod_exclusion.hh"
  "${INC_DIR}/dimension_ba_timeperiod_relation.hh"
  "${INC_DIR}/dimension_truncate_table_signal.hh"
  "${INC_DIR}/events.hh"
  "${INC_DIR}/event_cache_visitor.hh"
  "${INC_DIR}/exp_builder.hh"
  "${INC_DIR}/exp_parser.hh"
  "${INC_DIR}/exp_tokenizer.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/hst_svc_mapping.hh"
  "${INC_DIR}/impact_values.hh"
  "${INC_DIR}/internal.hh"
  "${INC_DIR}/inherited_downtime.hh"
  "${INC_DIR}/kpi.hh"
  "${INC_DIR}/kpi_ba.hh"
  "${INC_DIR}/kpi_boolexp.hh"
  "${INC_DIR}/kpi_event.hh"
  "${INC_DIR}/kpi_meta.hh"
  "${INC_DIR}/kpi_service.hh"
  "${INC_DIR}/kpi_status.hh"
  "${INC_DIR}/meta_service.hh"
  "${INC_DIR}/meta_service_status.hh"
  "${INC_DIR}/metric_book.hh"
  "${INC_DIR}/metric_listener.hh"
  "${INC_DIR}/monitoring_stream.hh"
  "${INC_DIR}/rebuild.hh"
  "${INC_DIR}/reporting_stream.hh"
  "${INC_DIR}/service_book.hh"
  "${INC_DIR}/service_listener.hh"
  "${INC_DIR}/timeperiod_map.hh"
)
target_link_libraries("${BAM}" ${QT_LIBRARIES})
set_target_properties("${BAM}" PROPERTIES PREFIX "")

# Testing.
set(
  TESTS_SOURCES
  ${TESTS_SOURCES}
  "${TEST_DIR}/exp_parser/get_postfix.cc"
  "${TEST_DIR}/exp_tokenizer/next.cc"
  "${TEST_DIR}/exp_builder/exp_builder.cc"
  "${TEST_DIR}/configuration/applier-boolexp.cc"
  PARENT_SCOPE
)
set(
  TESTS_LIBRARIES
  ${TESTS_LIBRARIES}
  "${BAM}"
  PARENT_SCOPE
)
if (0) # WITH_TESTING)
  set(TEST_LIBRARIES "${NEB}" "${BAM}" "roker")

  # ba tests.
  #   KPI change at recompute.
  set(TEST_NAME "bam_ba_kpi_change_at_recompute")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/ba/kpi_change_at_recompute.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # time tests.
  set(CHECK_TIMEPERIOD "check_timeperiod")
  add_executable("${CHECK_TIMEPERIOD}"
    "${TEST_DIR}/time/check_timeperiod.cc")
  target_link_libraries("${CHECK_TIMEPERIOD}" ${TEST_LIBRARIES})
  #   Week days tests.
  add_test("bam_time_week_day_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/after_period.conf")
  add_test("bam_time_week_day_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/before_period.conf")
  add_test("bam_time_week_day_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period.conf")
  add_test("bam_time_week_day_into_period_for_next_week"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_for_next_week.conf")
  add_test("bam_time_week_day_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_with_exclude_after.conf")
  add_test("bam_time_week_day_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_with_exclude_before.conf")
  add_test("bam_time_week_day_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_with_exclude_into.conf")
  #   Exceptions tests.
  #     Calendar date.
  add_test("bam_time_exception_calendar_date_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/after_period.conf")
  add_test("bam_time_exception_calendar_date_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/before_period.conf")
  add_test("bam_time_exception_calendar_date_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period.conf")
  add_test("bam_time_exception_calendar_date_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period_with_exclude_after.conf")
  add_test("bam_time_exception_calendar_date_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period_with_exclude_before.conf")
  add_test("bam_time_exception_calendar_date_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period_with_exclude_into.conf")
  add_test("bam_time_exception_calendar_date_skip_in_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_after_period.conf")
  add_test("bam_time_exception_calendar_date_skip_in_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_before_period.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period_with_exclude_after.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period_with_exclude_before.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period_with_exclude_into.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_after_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_before_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period_with_exclude_after.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period_with_exclude_before.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period_with_exclude_into.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_out_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_out_after_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_out_after_period_with_exclude_after"

=== generator/CMakeLists.txt ===
##
## Copyright 2017 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
include_directories("${PROJECT_SOURCE_DIR}/generator/inc")
set(INC_DIR "${PROJECT_SOURCE_DIR}/generator/inc/com/centreon/broker/generator")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/generator/src")

# generator module.
set(GENERATOR "90-generator")
set(GENERATOR "${GENERATOR}" PARENT_SCOPE)
add_library("${GENERATOR}" SHARED
  # Sources.
  "${SRC_DIR}/dummy.cc"
  "${SRC_DIR}/endpoint.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/receiver.cc"
  "${SRC_DIR}/sender.cc"
  # Headers.
  "${INC_DIR}/dummy.hh"
  "${INC_DIR}/endpoint.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/internal.hh"
  "${INC_DIR}/receiver.hh"
  "${INC_DIR}/sender.hh"
)
target_link_libraries("${GENERATOR}" ${QT_LIBRARIES})
set_target_properties("${GENERATOR}" PROPERTIES PREFIX "")

# Install rule.
install(TARGETS "${GENERATOR}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== neb/CMakeLists.txt ===
##
## Copyright 2009-2013,2015 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/neb/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/neb/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/neb/test")
include_directories("${INC_DIR}")

# NEB sources.
set(NEB_SOURCES
  # Sources.
  "${SRC_DIR}/acknowledgement.cc"
  "${SRC_DIR}/check.cc"
  "${SRC_DIR}/comment.cc"
  "${SRC_DIR}/custom_variable.cc"
  "${SRC_DIR}/custom_variable_status.cc"
  "${SRC_DIR}/dependency.cc"
  "${SRC_DIR}/downtime.cc"
  "${SRC_DIR}/event_handler.cc"
  "${SRC_DIR}/flapping_status.cc"
  "${SRC_DIR}/group.cc"
  "${SRC_DIR}/group_member.cc"
  "${SRC_DIR}/host.cc"
  "${SRC_DIR}/host_check.cc"
  "${SRC_DIR}/host_dependency.cc"
  "${SRC_DIR}/host_group.cc"
  "${SRC_DIR}/host_group_member.cc"
  "${SRC_DIR}/host_parent.cc"
  "${SRC_DIR}/host_service.cc"
  "${SRC_DIR}/host_service_status.cc"
  "${SRC_DIR}/host_status.cc"
  "${SRC_DIR}/instance.cc"
  "${SRC_DIR}/instance_configuration.cc"
  "${SRC_DIR}/instance_status.cc"
  "${SRC_DIR}/log_entry.cc"
  "${SRC_DIR}/module.cc"
  "${SRC_DIR}/responsive_instance.cc"
  "${SRC_DIR}/service.cc"
  "${SRC_DIR}/service_check.cc"
  "${SRC_DIR}/service_dependency.cc"
  "${SRC_DIR}/service_group.cc"
  "${SRC_DIR}/service_group_member.cc"
  "${SRC_DIR}/service_status.cc"
  "${SRC_DIR}/status.cc"
  # Headers.
  "${INC_DIR}/com/centreon/broker/neb/acknowledgement.hh"
  "${INC_DIR}/com/centreon/broker/neb/check.hh"
  "${INC_DIR}/com/centreon/broker/neb/comment.hh"
  "${INC_DIR}/com/centreon/broker/neb/custom_variable.hh"
  "${INC_DIR}/com/centreon/broker/neb/custom_variable_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/dependency.hh"
  "${INC_DIR}/com/centreon/broker/neb/downtime.hh"
  "${INC_DIR}/com/centreon/broker/neb/event_handler.hh"
  "${INC_DIR}/com/centreon/broker/neb/events.hh"
  "${INC_DIR}/com/centreon/broker/neb/flapping_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/group.hh"
  "${INC_DIR}/com/centreon/broker/neb/group_member.hh"
  "${INC_DIR}/com/centreon/broker/neb/host.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_check.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_dependency.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_group.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_group_member.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_parent.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_service.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_service_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/instance.hh"
  "${INC_DIR}/com/centreon/broker/neb/instance_configuration.hh"
  "${INC_DIR}/com/centreon/broker/neb/instance_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/internal.hh"
  "${INC_DIR}/com/centreon/broker/neb/log_entry.hh"
  "${INC_DIR}/com/centreon/broker/neb/module.hh"
  "${INC_DIR}/com/centreon/broker/neb/responsive_instance.hh"
  "${INC_DIR}/com/centreon/broker/neb/service.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_check.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_dependency.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_group.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_group_member.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/status.hh"
)

# Static library.
add_library("nebbase" STATIC ${NEB_SOURCES})
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-fPIC" COMPILER_HAS_FPIC)
if (COMPILER_HAS_FPIC)
  get_property(NEBBASE_CXXFLAGS
    TARGET "nebbase"
    PROPERTY COMPILE_FLAGS)
  if (NEBBASE_CXXFLAGS)
    set(NEBBASE_CXXFLAGS "${NEBBASE_CXXFLAGS} -fPIC")
  else ()
    set(NEBBASE_CXXFLAGS "-fPIC")
  endif ()
  set_property(TARGET "nebbase"
    PROPERTY COMPILE_FLAGS "${NEBBASE_CXXFLAGS}")
endif ()

# Centreon Broker module.
set(NEB "10-neb")
set(NEB "${NEB}" PARENT_SCOPE)
add_library("${NEB}" SHARED
  # Main source.
  "${SRC_DIR}/broker.cc"
  "${SRC_DIR}/downtime_scheduler.cc"
  "${SRC_DIR}/node_cache.cc"
  "${SRC_DIR}/node_events_connector.cc"
  "${SRC_DIR}/node_events_factory.cc"
  "${SRC_DIR}/node_events_stream.cc"
  "${SRC_DIR}/node_id.cc"
  "${SRC_DIR}/timeperiod_serializable.cc"
  "${SRC_DIR}/downtime_serializable.cc"
  "${SRC_DIR}/downtime_map.cc"

  # Inc
  "${INC_DIR}/com/centreon/broker/neb/downtime_scheduler.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_cache.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_events_connector.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_events_factory.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_events_stream.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_id.hh"
  "${INC_DIR}/com/centreon/broker/neb/timeperiod_serializable.hh"
  "${INC_DIR}/com/centreon/broker/neb/downtime_serializable.hh"
  "${INC_DIR}/com/centreon/broker/neb/downtime_map.hh"
)
if (CMAKE_COMPILER_IS_GNUCXX)
  # Flags needed to include all symbols in binary.
  target_link_libraries("${NEB}"
    "-Wl,--whole-archive" "nebbase" "-Wl,--no-whole-archive")
else ()
  target_link_libraries("${NEB}" "nebbase")
endif ()
target_link_libraries("${NEB}" ${QT_LIBRARIES})
set_target_properties("${NEB}" PROPERTIES PREFIX "")
install(TARGETS "${NEB}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

# Centreon Engine/Nagios module.
set(CBMOD "cbmod")
add_library("${CBMOD}" SHARED
  # Sources.
  "${PROJECT_SOURCE_DIR}/core/src/config/applier/init.cc"
  "${PROJECT_SOURCE_DIR}/core/src/config/applier/logger.cc"
  "${SRC_DIR}/callback.cc"
  "${SRC_DIR}/callbacks.cc"
  "${SRC_DIR}/initial.cc"
  "${SRC_DIR}/internal.cc"
  "${SRC_DIR}/monitoring_logger.cc"
  "${SRC_DIR}/neb.cc"
  "${SRC_DIR}/set_log_data.cc"
  "${SRC_DIR}/engcmd/factory.cc"
  "${SRC_DIR}/engcmd/endpoint.cc"
  "${SRC_DIR}/engcmd/engine_command.cc"
  "${SRC_DIR}/engcmd/internal.cc"
  "${SRC_DIR}/statistics/active_host_execution_time.cc"
  "${SRC_DIR}/statistics/active_host_latency.cc"
  "${SRC_DIR}/statistics/active_host_state_change.cc"
  "${SRC_DIR}/statistics/active_hosts_last.cc"
  "${SRC_DIR}/statistics/active_service_execution_time.cc"
  "${SRC_DIR}/statistics/active_service_latency.cc"
  "${SRC_DIR}/statistics/active_service_state_change.cc"
  "${SRC_DIR}/statistics/active_services_last.cc"
  "${SRC_DIR}/statistics/command_buffers.cc"
  "${SRC_DIR}/statistics/generator.cc"
  "${SRC_DIR}/statistics/hosts.cc"
  "${SRC_DIR}/statistics/hosts_actively_checked.cc"
  "${SRC_DIR}/statistics/hosts_checked.cc"
  "${SRC_DIR}/statistics/hosts_flapping.cc"
  "${SRC_DIR}/statistics/hosts_scheduled.cc"
  "${SRC_DIR}/statistics/passive_host_latency.cc"
  "${SRC_DIR}/statistics/passive_host_state_change.cc"
  "${SRC_DIR}/statistics/passive_hosts_last.cc"
  "${SRC_DIR}/statistics/passive_service_latency.cc"
  "${SRC_DIR}/statistics/passive_service_state_change.cc"
  "${SRC_DIR}/statistics/passive_services_last.cc"
  "${SRC_DIR}/statistics/plugin.cc"
  "${SRC_DIR}/statistics/services.cc"
  "${SRC_DIR}/statistics/services_actively_checked.cc"
  "${SRC_DIR}/statistics/services_checked.cc"
  "${SRC_DIR}/statistics/services_flapping.cc"
  "${SRC_DIR}/statistics/services_scheduled.cc"
  "${SRC_DIR}/statistics/total_host_state_change.cc"
  "${SRC_DIR}/statistics/total_hosts.cc"
  "${SRC_DIR}/statistics/total_service_state_change.cc"
  "${SRC_DIR}/statistics/total_services.cc"
  # Headers.
  "${INC_DIR}/com/centreon/broker/neb/callback.hh"
  "${INC_DIR}/com/centreon/broker/neb/callbacks.hh"
  "${INC_DIR}/com/centreon/broker/neb/initial.hh"
  "${INC_DIR}/com/centreon/broker/neb/internal.hh"
  "${INC_DIR}/com/centreon/broker/neb/monitoring_logger.hh"
  "${INC_DIR}/com/centreon/broker/neb/set_log_data.hh"
  "${INC_DIR}/com/centreon/broker/neb/engcmd/factory.hh"
  "${INC_DIR}/com/centreon/broker/neb/engcmd/endpoint.hh"
  "${INC_DIR}/com/centreon/broker/neb/engcmd/engine_command.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_host_execution_time.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_host_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_host_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_hosts_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_service_execution_time.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_service_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_service_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_services_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/command_buffers.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/compute_value.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/generator.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_actively_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_flapping.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_scheduled.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_host_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_host_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_hosts_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_service_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_service_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_services_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/plugin.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_actively_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_flapping.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_scheduled.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_host_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_hosts.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_service_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_services.hh"
)
get_property(CBMOD_DEFINES
  TARGET "${CBMOD}"
  PROPERTY COMPILE_DEFINITIONS)
list(APPEND CBMOD_DEFINES CBMOD)
set_property(TARGET "${CBMOD}"
  PROPERTY COMPILE_DEFINITIONS "${CBMOD_DEFINES}")
if (CMAKE_COMPILER_IS_GNUCXX)
  # Flags needed to include all symbols in shared library.
  target_link_libraries("${CBMOD}"
    "-Wl,--whole-archive" "nebbase" "rokerbase" "-Wl,--no-whole-archive")
else ()
  target_link_libraries("${CBMOD}" "nebbase" "rokerbase")
endif ()
set_target_properties("${CBMOD}" PROPERTIES PREFIX "")

# Unit tests.
if (0) # WITH_TESTING)
  include_directories("${PROJECT_SOURCE_DIR}/neb")
  include_directories("${PROJECT_SOURCE_DIR}/correlation/inc")
  include_directories("${PROJECT_SOURCE_DIR}/dumper/inc")
  set(TEST_LIBRARIES "${NEB}" "rokerbase" "roker" "rokerbase")
  # Custom Variable tests.
  #   Default constructor.
  set(TEST_NAME "neb_custom_variable_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/custom_variable/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy constructor.
  set(TEST_NAME "neb_custom_variable_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/custom_variable/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

=== rrd/CMakeLists.txt ===
##
## Copyright 2011-2013 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/rrd/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/rrd/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/rrd/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")

# Find librrd.
include(FindPkgConfig)
if (PKG_CONFIG_FOUND)
  pkg_check_modules(LIBRRD REQUIRED "librrd")
  if (LIBRRD_INCLUDE_DIRS)
    include_directories("${LIBRRD_INCLUDE_DIRS}")
    set(LIBRRD_INCLUDE_DIRS "${LIBRRD_INCLUDE_DIRS}" PARENT_SCOPE)
  endif ()
else ()
  # Find rrd.h
  find_path(LIBRRD_INCLUDE_DIR "rrd.h")
  if (NOT LIBRRD_INCLUDE_DIR)
    message(FATAL_ERROR "Could not find librrd's headers.")
  endif ()
  include_directories("${LIBRRD_INCLUDE_DIR}")
  set(LIBRRD_INCLUDE_DIRS "${LIBRRD_INCLUDE_DIR}" PARENT_SCOPE)

  # Find librrd.
  find_library(LIBRRD_LDFLAGS "rrd")
  if (NOT LIBRRD_LDFLAGS)
    message(FATAL_ERROR "Could not find librrd's library.")
  endif ()
  set(LIBRRD_LDFLAGS "${LIBRRD_LDFLAGS}" PARENT_SCOPE)
endif ()

# RRD module.
set(RRD "70-rrd")
set(RRD "${RRD}" PARENT_SCOPE)
add_library("${RRD}" SHARED
  # Sources.
  "${SRC_DIR}/backend.cc"
  "${SRC_DIR}/cached.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/creator.cc"
  "${SRC_DIR}/exceptions/open.cc"
  "${SRC_DIR}/exceptions/update.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/lib.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/output.cc"
  # Headers.
  "${INC_DIR}/com/centreon/broker/rrd/backend.hh"
  "${INC_DIR}/com/centreon/broker/rrd/cached.hh"
  "${INC_DIR}/com/centreon/broker/rrd/connector.hh"
  "${INC_DIR}/com/centreon/broker/rrd/creator.hh"
  "${INC_DIR}/com/centreon/broker/rrd/exceptions/open.hh"
  "${INC_DIR}/com/centreon/broker/rrd/exceptions/update.hh"
  "${INC_DIR}/com/centreon/broker/rrd/factory.hh"
  "${INC_DIR}/com/centreon/broker/rrd/lib.hh"
  "${INC_DIR}/com/centreon/broker/rrd/output.hh"
)
target_link_libraries("${RRD}" ${QT_LIBRARIES})
set_target_properties("${RRD}" PROPERTIES PREFIX "")

# Compile with librrd flags.
if (LIBRRD_CFLAGS)
  get_source_file_property(RRD_SOURCE_CXXFLAGS "${SRC_DIR}/lib.cc" COMPILE_FLAGS)
  if (LIBRRD_SOURCE_CXXFLAGS)
    set_source_files_properties("${SRC_DIR}/lib.cc" PROPERTIES
      COMPILE_FLAGS "${RRD_SOURCE_CXXFLAGS} ${LIBRRD_CFLAGS}")
  else ()
    set_source_files_properties("${SRC_DIR}/lib.cc" PROPERTIES
      COMPILE_FLAGS "${LIBRRD_CFLAGS}")
  endif ()
endif ()
target_link_libraries("${RRD}" ${LIBRRD_LDFLAGS})

# Testing.
set(
        TESTS_SOURCES
        ${TESTS_SOURCES}
        "${TEST_DIR}/exceptions.cc"
        "${TEST_DIR}/rrd.cc"
        PARENT_SCOPE
)
set(
        TESTS_LIBRARIES
        ${TESTS_LIBRARIES}
        "${RRD}"
        PARENT_SCOPE
)

# Install rule.
install(TARGETS "${RRD}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== storage/CMakeLists.txt ===
##
## Copyright 2011-2013 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/storage/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/storage/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/storage/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
include_directories("${PROJECT_SOURCE_DIR}/rrd/inc")
set(INC_DIR "${INC_DIR}/com/centreon/broker/storage")

# Storage module.
set(STORAGE "20-storage")
set(STORAGE "${STORAGE}" PARENT_SCOPE)
add_library("${STORAGE}" SHARED
  # Sources.
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/exceptions/perfdata.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/index_mapping.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/metric.cc"
  "${SRC_DIR}/metric_mapping.cc"
  "${SRC_DIR}/parser.cc"
  "${SRC_DIR}/perfdata.cc"
  "${SRC_DIR}/rebuild.cc"
  "${SRC_DIR}/rebuilder.cc"
  "${SRC_DIR}/remove_graph.cc"
  "${SRC_DIR}/status.cc"
  "${SRC_DIR}/stream.cc"
  # Headers.
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/events.hh"
  "${INC_DIR}/exceptions/perfdata.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/index_mapping.hh"
  "${INC_DIR}/internal.hh"
  "${INC_DIR}/metric.hh"
  "${INC_DIR}/metric_mapping.hh"
  "${INC_DIR}/parser.hh"
  "${INC_DIR}/perfdata.hh"
  "${INC_DIR}/rebuild.hh"
  "${INC_DIR}/rebuilder.hh"
  "${INC_DIR}/remove_graph.hh"
  "${INC_DIR}/status.hh"
  "${INC_DIR}/stream.hh"
)
target_link_libraries("${STORAGE}" ${QT_LIBRARIES})
set_target_properties("${STORAGE}" PROPERTIES PREFIX "")

# Testing.
set(
  TESTS_SOURCES
  ${TESTS_SOURCES}
  "${TEST_DIR}/parser/parse_perfdata.cc"
  PARENT_SCOPE
)
set(
  TESTS_LIBRARIES
  ${TESTS_LIBRARIES}
  "${STORAGE}"
  PARENT_SCOPE
)

if (0) # WITH_TESTING)
  set(TEST_LIBRARIES "${STORAGE}" "10-neb" "rokerbase" "roker" "rokerbase")

  # Perfdata exception tests.
  #   Throw.
  set(TEST_NAME "storage_exceptions_perfdata_throw")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/perfdata/throw.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Rethrow.
  set(TEST_NAME "storage_exceptions_perfdata_rethrow")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/perfdata/rethrow.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Clone.
  set(TEST_NAME "storage_exceptions_perfdata_clone")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/perfdata/clone.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # Perfdata object tests.
  #   Default construction.
  set(TEST_NAME "storage_perfdata_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/perfdata/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "storage_perfdata_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/perfdata/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment operator.
  set(TEST_NAME "storage_perfdata_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/perfdata/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # Metric event tests.
  #   Default construction.
  set(TEST_NAME "storage_metric_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/metric/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "storage_metric_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/metric/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment operator.
  set(TEST_NAME "storage_metric_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/metric/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # Rebuild event tests.
  #   Default construction.
  set(TEST_NAME "storage_rebuild_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/rebuild/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "storage_rebuild_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/rebuild/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment operator.
  set(TEST_NAME "storage_rebuild_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/rebuild/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # Remove graph event tests.
  #   Default construction.
  set(TEST_NAME "storage_remove_graph_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/remove_graph/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "storage_remove_graph_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/remove_graph/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment operator.
  set(TEST_NAME "storage_remove_graph_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/remove_graph/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # Status event tests.
  #   Default construction.
  set(TEST_NAME "storage_status_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/status/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "storage_status_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/status/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment operator.
  set(TEST_NAME "storage_status_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/status/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # Parser tests.
  #   Simple perfdata parsing.
  set(TEST_NAME "storage_parser_parse_simple")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/parser/parse_simple.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Complex perfdata parsing.
  set(TEST_NAME "storage_parser_parse_complex")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/parser/parse_complex.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Incorrect perfdata parsing.
  set(TEST_NAME "storage_parser_parse_incorrect")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/parser/parse_incorrect.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Loop perfdata parsing.
  set(TEST_NAME "storage_parser_parse_loop")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/parser/parse_loop.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
endif ()

# Install rule.
install(TARGETS "${STORAGE}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== test/CMakeLists.txt ===
##
## Copyright 2016-2017 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

include(ExternalProject)

set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/3rdparty)

set(GOOGLE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
ExternalProject_Add( googletest
                     GIT_REPOSITORY https://github.com/google/googletest/
                     TIMEOUT 10
                     INSTALL_COMMAND ""
                     LOG_DOWNLOAD ON
                     LOG_CONFIGURE ON
                     LOG_BUILD ON
                     CMAKE_ARGS -DCMAKE_CXX_FLAGS=${GOOGLE_CXX_FLAGS} -DCMAKE_C_FLAGS=${CMAKE_C_FLAGS})

ExternalProject_Get_Property(googletest source_dir)
ExternalProject_Get_Property(googletest binary_dir)

link_directories(${binary_dir}/lib)
include_directories(${source_dir}/googletest/include)

# Tests directory.
set(TESTS_DIR ${PROJECT_SOURCE_DIR}/core/test)

# Include directories.
include_directories(${PROJECT_SOURCE_DIR}/bam/inc)
include_directories(${PROJECT_SOURCE_DIR}/storage/inc)
include_directories(${PROJECT_SOURCE_DIR}/lua/inc)
include_directories(${PROJECT_SOURCE_DIR}/neb/inc)
include_directories(${PROJECT_SOURCE_DIR}/rrd/inc)

# Unit test executable.
add_executable(ut
  # Core sources.
  ${TESTS_DIR}/main.cc
  ${TESTS_DIR}/bbdo/input_buffer/erase.cc
  ${TESTS_DIR}/bbdo/input_buffer/extract.cc
  ${TESTS_DIR}/ceof/ceof_parser/parse.cc
  ${TESTS_DIR}/compression/stream/memory_stream.hh
  ${TESTS_DIR}/compression/stream/read.cc
  ${TESTS_DIR}/compression/stream/write.cc
  ${TESTS_DIR}/compression/zlib/zlib.cc
  ${TESTS_DIR}/exceptions/msg/default.cc
  ${TESTS_DIR}/file/splitter/default.cc
  ${TESTS_DIR}/file/splitter/concurrent.cc
  ${TESTS_DIR}/file/splitter/more_than_max_size.cc
  ${TESTS_DIR}/file/splitter/resume.cc
  ${TESTS_DIR}/file/splitter/split.cc
  ${TESTS_DIR}/file/test_file.hh
  ${TESTS_DIR}/file/test_file.cc
  ${TESTS_DIR}/file/test_fs_browser.hh
  ${TESTS_DIR}/file/test_fs_browser.cc
  ${TESTS_DIR}/multiplexing/muxer/read.cc
  # Module sources.
  ${TESTS_SOURCES}
)

add_dependencies(ut googletest)
target_link_libraries(ut gtest ${TESTS_LIBRARIES} ${NEB} rokerbase roker
  pthread gcov)

add_test(NAME tests COMMAND ut)

if (WITH_COVERAGE)
  set(COVERAGE_EXCLUDES '*/test/*' '/usr/include/*' '${CMAKE_BINARY_DIR}/*')
  SETUP_TARGET_FOR_COVERAGE(
      NAME test-coverage
      EXECUTABLE ut
      DEPENDENCIES ut
  )
endif ()

=== debian/changelog ===
centreon-broker (19.10.2-1) unstable; urgency=medium

  * Add debian/watch
  * New upstream version 19.10.2
  * Adjust debian/rules to new source layout
  * Use packaged json11

 -- Sebastien Delafond <seb@debian.org>  Fri, 27 Dec 2019 08:04:19 +0100

=== debian/control ===
Source: centreon-broker
Section: net
Priority: optional
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Sebastien Delafond <seb@debian.org>
Build-Depends: debhelper (>= 11), cmake, libcentreon-clib, libqt4-dev, libqt4-opengl-dev, zlib1g-dev, pkg-config, librrd-dev, liblua5.3-dev, libgnutls28-dev, libjson11-1-dev
Standards-Version: 4.2.1
Homepage: https://github.com/centreon/centreon-broker
Vcs-Browser: https://salsa.debian.org/centreon-team/centreon-broker
Vcs-Git: https://salsa.debian.org/centreon-team/centreon-broker.git

Package: centreon-broker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, centreon-engine, rrdtool, adduser, libqt4-sql-mysql
Description: Network, system, applicative supervision and monitoring - broker
 Centreon is a modular and flexible platform for network, system and
 applicative supervision and monitoring.
 .
  * monitoring of network services
  * monitoring of host resources
  * simple plugin design that allows users to easily develop their own
    service checks
  * parallelized service checks
  * ability to define network hierarchies
  * contact notifications when service or host problems occur and get
    resolved (via email, page, or user-defined method)
  * ability to define event handlers to be run during service or host
    events for proactive problem resolution
  * automatic log file rotation
  * support for implementing redundant monitoring hosts
 .
 This package contains the broker daemon.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
# see https://github.com/centreon/centreon-broker/issues/139
CXXFLAGS+=$(CPPFLAGS) -std=c++98 -fpermissive

export CMAKE_OPTIONS := \
  -DCMAKE_C_COMPILER="$(CC)" \
  -DCMAKE_CXX_COMPILER="$(CXX)" \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_PREFIX=/usr \
  -DWITH_PREFIX_BIN=/usr/sbin \
  -DWITH_PREFIX_CONF=/etc/centreon-broker \
  -DWITH_PREFIX_LIB=/usr/lib/centreon-broker \
  -DWITH_PREFIX_VAR=/var/lib/centreon-broker \
  -DWITH_LOGROTATE_SCRIPT=1 \
  -DWITH_VAR_DIR=/var/log/centreon-broker \
  -DWITH_PREFIX_MODULES=/usr/lib/centreon-broker/modules \
  -DWITH_PKGCONFIG_SCRIPT=1 \
  -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
  -DWITH_DAEMONS='central-broker;central-rrd' \
  -DWITH_STARTUP_SCRIPT=systemd \
  -DWITH_STARTUP_DIR=/lib/systemd/system \
  -DWITH_USER=centreon-broker \
  -DWITH_GROUP=centreon-broker \
  -DWITH_CONFIG_FILES=1

%:
	dh $@ --sourcedirectory=.

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=. -- $(CMAKE_OPTIONS)

=== debian/watch ===
version=3
https://github.com/centreon/centreon-broker/tags .*/(\d[\d\.]*)\.tar\.gz debian uupdate
